import numpy as np
import pylab as pl
import scipy as sp
from scipy import linalg,random

def meth_newton(f,df,x0,eps):
    n=len(x0)
    itmax=20
    it=0
    tabx=np.zeros(shape=(n,itmax+1))
    tabcrit=np.zeros(itmax+1)
    x=x0.copy()
    tabx[0:,0]=x
    crit=sp.linalg.norm(f(x))
    tabcrit[0]=crit
    while crit > eps and it < itmax:
        it += 1
        dx=sp.linalg.solve(df(x),f(x))
        x = x-dx
        tabx[0:,it]=x
        crit=sp.linalg.norm(f(x))
        tabcrit[it]=crit
    return tabx,tabcrit,it

def tdf(f,x,h):
    n=len(x)
    ei=np.eye(n,n)
    y=np.zeros(shape=(n,n))
    for j in range(n):
        yj=f(x+h*ei[0:,j])-f(x)
        y[0:,j]=yj
    y=y/h
    return y
        
                        
def meth_quasinewton(f,h,x0,eps):
    n=len(x0)
    itmax=20
    it=0
    tabx=np.zeros(shape=(n,itmax+1))
    tabcrit=np.zeros(itmax+1)
    x=x0.copy()
    tabx[0:,0]=x
    crit=sp.linalg.norm(f(x))
    tabcrit[0]=crit
    while crit>eps and it<itmax:
        it +=1
        dx=sp.linalg.solve(tdf(f,x,h),f(x))
        x=x-dx
        tabx[0:,it]=x
        crit=sp.linalg.norm(f(x))
        tabcrit[it]=crit
    return tabx,tabcrit,it
