function [tabx,tabcrit]=meth_newton(f,df,x0,eps)

itmax=20;
iter=0;
tabx=[];
tabcrit=[];

x=x0;
tabx=[x];

crit=norm(f(x));
tabcrit=[crit];

//for k=1:N
while (crit>eps)&(iter<itmax)
dx=df(x)\f(x);
x=x-dx;
tabx=[tabx,x];
iter=iter+1;
crit=norm(f(x));
tabcrit=[tabcrit,crit];
end

endfunction

function [tabx,tabcrit]=meth_newton_mod(f,df,x0,eps,p)

itmax=20;
iter=0;
tabx=[];
tabcrit=[];

x=x0;
tabx=[x];

crit=norm(f(x));
tabcrit=[crit];

//for k=1:N
while (crit>eps)&(iter<itmax)
dx=df(x)\f(x);
x=x-p*dx;
tabx=[tabx,x];
iter=iter+1;
crit=norm(f(x));
tabcrit=[tabcrit,crit];
end

endfunction

function yh=dfh(f,h,x)
fx=f(x);
yh=[];
d=length(x);
ad=eye(d,d);
for j=1:d
ej=ad(:,j);
yhj=f(x+h*ej)-fx;
yh=[yh,yhj];
end
yh=yh/h;

endfunction

function y=tdf(f,x,h)
dim=length(x);
ei=eye(dim,dim);

y=[];
for j=1:dim
yj=f(x+h*ei(:,j))-f(x);
y=[y,yj];
end
y=y/h;

endfunction



function [tabx,tabcrit]=meth_quasinewton(f,h,x0,eps)

itmax=20;
iter=0;
tabx=[];
tabcrit=[];

x=x0;
tabx=[x];

crit=norm(f(x));
tabcrit=[crit];

//for k=1:N
while (crit>eps)&(iter<itmax)

dx=tdf(f,x,h)\f(x);
x=x-dx;
tabx=[tabx,x];
iter=iter+1;
crit=norm(f(x));
tabcrit=[tabcrit,crit];
end

endfunction




